#ifndef _MDLIMPORT_H_
#define _MDLIMPORT_H_

#if MAX_SDK < 2013
#define _UNICODE_MODULE_FOR_MBCS_MAX
#endif //MAX_SDK < 2013

#if MAX_SDK <= 2011
enum BoneObj_Params { 
	boneobj_width, boneobj_height, boneobj_taper, boneobj_length,
	boneobj_sidefins, boneobj_sidefins_size, boneobj_sidefins_starttaper, boneobj_sidefins_endtaper,
	boneobj_frontfin, boneobj_frontfin_size, boneobj_frontfin_starttaper, boneobj_frontfin_endtaper,
	boneobj_backfin,  boneobj_backfin_size,  boneobj_backfin_starttaper,  boneobj_backfin_endtaper,
	boneobj_genmap };
#endif //MAX_SDK <= 2011

#if MAX_SDK >= 2013
#define end p_end
#endif //MAX_SDK >= 2013

#include "../Shared/StringBuffer.h"

#ifdef _UNICODE
	// If the module uses Unicode and needs to translate to
	// an MBCS Max, define _UNICODE_MODULE_FOR_MBCS_MAX
	#ifdef _UNICODE_MODULE_FOR_MBCS_MAX
#define _M_STRCMP	strcmp
#define _M_STRCMPI	_strcmpi
#define MStringBuffer TStringBufferA
//template<int _bufsize> using MStringBuffer = TStringBufferA<_bufsize>;
	#else
#define _M_STRCMP	wcscmp
#define _M_STRCMPI	_wcsicmp
//template<int _bufsize> using MStringBuffer = TStringBufferW<_bufsize>;
#define MStringBuffer TStringBufferW
#define _M_ISUNICODE
	#endif
#else
#define _M_STRCMP	strcmp
#define _M_STRCMPI	_strcmpi
#define MStringBuffer TStringBufferA
//template<int _bufsize> using MStringBuffer = TStringBufferA<_bufsize>;
#endif

#include <windows.h>
#include <Max.h>
#include <stdio.h>
#include <direct.h>
#include <commdlg.h>
#include <dummy.h>
#include <istdplug.h>
#include <stdmat.h>
#include <gamma.h>
#include <helpsys.h>
#include <buildver.h>
#include <inode.h>
#include <triobj.h>
#include <mesh.h>
#include "Memory.h"
//#include "mods.h"
#include <iparamb2.h>
#include "utilapi.h"
#include "istdplug.h"
#include "modstack.h"
#include "simpmod.h"
#include <WinUtil.h>
#include <UtilAPI.h>
#include <iskin.h>
#include "MeshNormalSpec.h"
#include <plugapi.h>

#define PTR_WARN	__pragma(warning(suppress: 4244))

class CStringConvert{
protected:
	TStringBufferA<1024>	m_ABuf;
	TStringBufferW<1024>	m_WBuf;
public:
	const MCHAR* UTF8ToM(const char* pStr);
	const MCHAR* UTF16ToM(const wchar_t* pStr);
	const char* MToUTF8(const MCHAR* pStr);
	const wchar_t* MToUTF16(const MCHAR* pStr);
	const MCHAR* operator()(const char* pStr){
		return UTF8ToM(pStr);
	}
	const MCHAR* operator()(const wchar_t* pStr){
		return UTF16ToM(pStr);
	}
};

class CMDLImpClassDesc : public ClassDesc2 {
public:
	int IsPublic();
	void* Create(BOOL loading = FALSE);
	const MCHAR* ClassName();
	SClass_ID SuperClassID();
	Class_ID ClassID();
	const MCHAR* Category();
	static CMDLImpClassDesc	s_Instance;
};

class CCarImpClassDesc : public ClassDesc2 {
public:
	int IsPublic();
	void* Create(BOOL loading = FALSE);
	const MCHAR* ClassName();
	SClass_ID SuperClassID();
	Class_ID ClassID();
	const MCHAR* Category();
	static CCarImpClassDesc	s_Instance;
};

class CRigImpClassDesc : public ClassDesc2 {
public:
	int IsPublic();
	void* Create(BOOL loading = FALSE);
	const MCHAR* ClassName();
	SClass_ID SuperClassID();
	Class_ID ClassID();
	const MCHAR* Category();
	static CRigImpClassDesc	s_Instance;
};

#endif //!_MDLIMPORT_H_
