#include <Windows.h>
#include "MdlImport.h"

HINSTANCE	g_hInstance;

BOOL WINAPI DllMain(HINSTANCE hModule, ULONG fdwReason, LPVOID){
	if(fdwReason == DLL_PROCESS_ATTACH){
		g_hInstance = hModule;
		DisableThreadLibraryCalls(g_hInstance);
	} else if (fdwReason == DLL_PROCESS_DETACH){
	}
	return TRUE;
}

extern "C" {
	__declspec(dllexport) const char* LibDescription() {
		return "SR3 model importer";
	}

	__declspec(dllexport) int LibNumberClasses() {
		int count;
		count = 1 //mdl
			+1 //rig
			+2 //car
			;
		return count;
	}

	__declspec(dllexport) ClassDesc *LibClassDesc(int i) {
		switch (i){
		case 0: return &CMDLImpClassDesc::s_Instance;
		case 1: return &CRigImpClassDesc::s_Instance;
		case 2: return &CCarImpClassDesc::s_Instance;
		}
		return NULL;
	}

	__declspec(dllexport) ULONG LibVersion() {
		return VERSION_3DSMAX;
	}

	//Not suporting auto defer because of globally loaded data (ActorSockets)
	__declspec(dllexport) ULONG CanAutoDefer(){
		return 0;
	}
}

TCHAR *GetString(int id){
	static TCHAR buf[256];
	if (g_hInstance)
		return LoadString(g_hInstance, id, buf, sizeof(buf)) ? buf : NULL;
	return NULL;
}