#ifndef _CONFIG_H_
#define _CONFIG_H_
#include "StringBuffer.h"
#include "Str.h"
#include "String.h"
#include "Lists.h"


class CConfig {
public:
	CConfig();
	bool GetLineEnd(char* pStr, char** ppEnd, char** ppNextStart = NULL);
	char* SkipWS(char* pStr);
	char* InverseGetLastWS(char* pStart, char* pStr);
	bool Parse(const char* pFileName, bool (*pfnCallback)(const char* key, const char* value, void* ctx), void* ctx = NULL);
	template<typename T> bool TParse(const char* pFileName, bool (*pfnCallback)(const char* key, const char* value, T* ctx), T* ctx = NULL){
		typedef bool (*fnCallback)(const char* key, const char* value, void* ctx);
		return Parse(pFileName, (fnCallback)pfnCallback, (void*)ctx);
	}
	char* FindStr(char* pStr, char* pCompare);
	void ReadQuoted(char* pStr, CStringBufferA &res);
};


class CSimpleConfig{
protected:
	class CConfigValue{
	public:
		CStringA	m_Key;
		CStringA	m_Value;
	};
	SList<CConfigValue>	m_Values;
	void AddValue(const char* pKey, const char* pValue);
	static bool ParseCallback(const char* key, const char* value, CSimpleConfig* ctx);
public:
	CSimpleConfig();
	~CSimpleConfig();
	void Clear();
	bool Load(const char* pPath);
	const char* GetValue(const char* pKey);
};

#endif //!_CONFIG_H_