#ifndef _DEBUG_H_
#define _DEBUG_H_


#define MEMSTATS_URL		(L"dyn://memstats")
#define MEMSTATS_HANDLER	(L"memstats")

#ifdef _DEBUG
#if 0
IStream* GenerateMemStatsPage();
#endif //0

HRESULT HRProxy(HRESULT hr, const wchar_t*pText, const char* pFunction, const char* pFile, int line, bool okonly);
bool BoolProxy(bool b, const wchar_t*pText, const char* pFunction, const char* pFile, int line);

#define HRPROXY(_test) HRProxy(_test, L#_test, __FUNCTION__, __FILE__, __LINE__, true)
#define HRPROXYS(_test) HRProxy(_test, L#_test, __FUNCTION__, __FILE__, __LINE__, false)
#define BOOLPROXY(_test) BoolProxy(_test, L#_test, __FUNCTION__, __FILE__, __LINE__)
#define DebugMsg(_fmt, ...) MsgFormated(_fmt, __VA_ARGS__)
#else //_DEBUG
#define GenerateMemStatsPage() (NULL)

#define HRPROXY(_test) _test
#define HRPROXYS(_test) _test
#define BOOLPROXY(_test) _test
#define DebugMsg(_fmt, ...) __noop
//inline void DebugMsg(_fmt, ...){}
#endif //!_DEBUG

#endif //!_DEBUG_H_
