#include <Windows.h>
#include <stdio.h>
#include <stdlib.h>
#include <conio.h>
#include "Memory.h"
#include "StdLib.h"
#include "String.h"
#include "StringBuffer.h"
#include "Buffer.h"

bool LoadTextfileToBufferA(const char* pFileName, CStringBufferA &buf){
	file f;
	size_32 size;
	buf.Clear();
	f = fopen_(pFileName, "r");
	if (f == INVALID_FILE)
		return false;
	size = fsize_(f);
	buf.Alloc(size+1);
	if ((size_32)buf.GetBufferSize() < size+1)
		return fclose_(f), false;
	if (fread_(buf.GetBufferPtr(), size, f) != size)
		return buf.Clear(), fclose_(f), false;
	*(buf.GetBufferPtr()+size) = 0;
	
	fclose_(f);
	return true;
}

bool LoadTextfileToBufferW(const char* pFileName, CStringBuffer &buf){
	CStringBufferA abuf;
	if (!LoadTextfileToBufferA(pFileName, abuf))
		return false;
	buf = abuf;
	return true;
}

bool LoadTextfileToBufferA(const wchar_t* pFileName, CStringBufferA &buf){
	CStringBufferA abuf;
	abuf = pFileName;
	return LoadTextfileToBufferA((const char*)abuf, buf);
}

bool LoadTextfileToBufferW(const wchar_t* pFileName, CStringBuffer &buf){
	CStringBufferA abuf;
	abuf = pFileName;
	return LoadTextfileToBufferW((const char*)abuf, buf);
}

bool LoadFileToBuffer(const char* pFileName, CDynMemoryBuffer &buf){
	file f;
	size_32 len;
	buf.Clear(false);
	f = fopen_(pFileName, "r");
	if (f == INVALID_FILE)
		return false;
	len = fsize_(f);
	if (!buf.EnsureSize(len))
		return fclose_(f), false;
	buf.SetSize(len);
	return (fread_(buf.GetPtr(), len, f) == len) ? (fclose_(f), true) : (fclose_(f), false);
}

bool WriteBufferToFile(const char* pFileName, CDynMemoryBuffer &buf){
	file f;
	f = fopen_(pFileName, "w");
	if (f == INVALID_FILE)
		return false;
	if (fwrite_(buf.GetPtr(), buf.GetSize(), f) != buf.GetSize())
		return fseek_(f, 0, SEEK_SET), fseteof_(f), fclose_(f), false;
	return fclose_(f), true;
}

bool WriteStringBufferToFile(const char* pFileName, CStringBufferA &buf){
	file f;
	f = fopen_(pFileName, "w");
	if (f == INVALID_FILE)
		return false;
	if (fwrite_(buf.GetBufferPtr(), buf.GetOffset(), f) != buf.GetOffset())
		return fseek_(f, 0, SEEK_SET), fseteof_(f), fclose_(f), false;
	return fclose_(f), true;
}