#include "MemoryMappedFile.h"



CMappedFile::CMappedFile(){
	m_hFile = INVALID_HANDLE_VALUE;
	m_hMapping = NULL;
	m_pMemory = NULL;
	m_Size = 0;
}

CMappedFile::~CMappedFile(){
	Close();
}

bool CMappedFile::Open(const char* pFilename){
	Close();
	char lBuf[512];
	DWORD r;
	if ((m_hFile = CreateFileA(pFilename, GENERIC_READ, FILE_SHARE_READ, NULL, OPEN_EXISTING, 0, INVALID_HANDLE_VALUE)) == INVALID_HANDLE_VALUE)
		return false;
	if ((m_Size = GetFileSize(m_hFile, NULL)) == 0)
		return Close(), false;
	if ((m_hMapping = CreateFileMappingA(m_hFile, NULL, PAGE_READONLY, 0, 0, NULL)) == NULL)
		return Close(), false;
	BOOL b = ReadFile(m_hMapping, lBuf, 512, &r, NULL);

	if ((m_pMemory = MapViewOfFile(m_hMapping, FILE_MAP_READ, 0, 0, 0)) == NULL)
		return Close(), false;
	return true;
}

bool CMappedFile::Create(const char* pName, int size){
	Close();
	m_hFile = INVALID_HANDLE_VALUE;
	m_Size = (DWORD)size;

	if ((m_hMapping = CreateFileMappingA(NULL, NULL, PAGE_READWRITE, 0, m_Size, pName)) == NULL)
		return Close(), false;

	if ((m_pMemory = MapViewOfFile(m_hMapping, FILE_MAP_READ|FILE_MAP_WRITE, 0, 0, 0)) == NULL)
		return Close(), false;
	return true;
}


bool CMappedFile::OpenExisting(const char* pName, bool r, bool w){
	Close();
	if ((m_hMapping = OpenFileMappingA((r ?  FILE_MAP_READ : 0) | (w ? FILE_MAP_WRITE : 0), FALSE, pName)) == NULL)
		return Close(), false;
	m_Size = GetFileSize(m_hMapping, NULL);
	if ((m_pMemory = MapViewOfFile(m_hMapping, (r ?  FILE_MAP_READ : 0) | (w ? FILE_MAP_WRITE : 0), 0, 0, 0)) == NULL)
		return Close(), false;

	return true;
}

void CMappedFile::Close(){
	DWORD e = GetLastError();
	if (m_pMemory)
		UnmapViewOfFile(m_pMemory);
	if (m_hMapping)
		CloseHandle(m_hMapping);
	if (m_hFile)
		CloseHandle(m_hFile);
	m_hFile = INVALID_HANDLE_VALUE;
	m_hMapping = NULL;
	m_pMemory = NULL;
	m_Size = 0;
}

PVOID CMappedFile::GetMemory(){
	return m_pMemory;
}

DWORD CMappedFile::GetSize(){
	return m_Size;
}