#ifndef _XMLHELPERS_H_
#define _XMLHELPERS_H_

#include <Windows.h>
#include "XML.h"
#include "StringBuffer.h"
#include "String.h"

inline bool GetNamedAttributeStr(IXMLData* pNode, CStringW *pBuf, const IXML_ST* pName){
	IXMLData* pAttr;
	pAttr = pNode->GetNamedAttribute(pName, NULL);
	if (!pAttr || !pAttr->GetValue())
		return false;
	(*pBuf) = pAttr->GetValue();
	return true;
}

inline bool GetNamedAttributeStrA(IXMLData* pNode, CStringA *pBuf, const IXML_ST* pName){
	IXMLData* pAttr;
	pAttr = pNode->GetNamedAttribute(pName, NULL);
	if (!pAttr || !pAttr->GetValue())
		return false;
	(*pBuf) = pAttr->GetValue();
	return true;
}

inline bool GetNamedAttributeStrBuf(IXMLData* pNode, CStringBuffer *pBuf, const IXML_ST* pName){
	IXMLData* pAttr;
	pAttr = pNode->GetNamedAttribute(pName, NULL);
	if (!pAttr || !pAttr->GetValue())
		return false;
	(*pBuf) = pAttr->GetValue();
	return true;
}

inline bool GetNamedAttributeStrBufA(IXMLData* pNode, CStringBufferA *pBuf, const IXML_ST* pName){
	IXMLData* pAttr;
	pAttr = pNode->GetNamedAttribute(pName, NULL);
	if (!pAttr || !pAttr->GetValue())
		return false;
	(*pBuf) = pAttr->GetValue();
	return true;
}

inline bool GetNamedAttribute_s32(IXMLData* pNode, ssize_32 *pValue, const IXML_ST* pName){
	IXMLData* pAttr;
	pAttr = pNode->GetNamedAttribute(pName, NULL);
	if (!pAttr || !pAttr->GetValue())
		return false;
	return (IXML_SCAN(pAttr->GetValue(), IXML_STR("%d"), pValue) == 1);
}

inline bool GetNamedAttribute_s64(IXMLData* pNode, ssize_64 *pValue, const IXML_ST* pName){
	IXMLData* pAttr;
	pAttr = pNode->GetNamedAttribute(pName, NULL);
	if (!pAttr || !pAttr->GetValue())
		return false;
	return (IXML_SCAN(pAttr->GetValue(), IXML_STR("%I64d"), pValue) == 1);
}

inline bool GetNamedAttribute_32(IXMLData* pNode, size_32 *pValue, const IXML_ST* pName){
	IXMLData* pAttr;
	pAttr = pNode->GetNamedAttribute(pName, NULL);
	if (!pAttr || !pAttr->GetValue())
		return false;
	return (IXML_SCAN(pAttr->GetValue(), IXML_STR("%u"), pValue) == 1);
}

inline bool GetNamedAttribute_64(IXMLData* pNode, ssize_64 *pValue, const IXML_ST* pName){
	IXMLData* pAttr;
	pAttr = pNode->GetNamedAttribute(pName, NULL);
	if (!pAttr || !pAttr->GetValue())
		return false;
	return (IXML_SCAN(pAttr->GetValue(), IXML_STR("%I64u"), pValue) == 1);
}

inline bool GetNamedAttribute_int32(IXMLData* pNode, int *pValue, const IXML_ST* pName){
	IXMLData* pAttr;
	pAttr = pNode->GetNamedAttribute(pName, NULL);
	if (!pAttr || !pAttr->GetValue())
		return false;
	return (IXML_SCAN(pAttr->GetValue(), IXML_STR("%d"), pValue) == 1);
}

inline bool GetNamedAttribute_int64(IXMLData* pNode, __int64 *pValue, const IXML_ST* pName){
	IXMLData* pAttr;
	pAttr = pNode->GetNamedAttribute(pName, NULL);
	if (!pAttr || !pAttr->GetValue())
		return false;
	return (IXML_SCAN(pAttr->GetValue(), IXML_STR("%I64d"), pValue) == 1);
}

inline bool GetNamedAttribute_uint32(IXMLData* pNode, unsigned int *pValue, const IXML_ST* pName){
	IXMLData* pAttr;
	pAttr = pNode->GetNamedAttribute(pName, NULL);
	if (!pAttr || !pAttr->GetValue())
		return false;
	return (IXML_SCAN(pAttr->GetValue(), IXML_STR("%u"), pValue) == 1);
}

inline bool GetNamedAttribute_uint64(IXMLData* pNode, unsigned __int64 *pValue, const IXML_ST* pName){
	IXMLData* pAttr;
	pAttr = pNode->GetNamedAttribute(pName, NULL);
	if (!pAttr || !pAttr->GetValue())
		return false;
	return (IXML_SCAN(pAttr->GetValue(), IXML_STR("%I64u"), pValue) == 1);
}

inline bool GetNamedAttribute_float(IXMLData* pNode, float *pValue, const IXML_ST* pName){
	IXMLData* pAttr;
	pAttr = pNode->GetNamedAttribute(pName, NULL);
	if (!pAttr || !pAttr->GetValue())
		return false;
	return (IXML_SCAN(pAttr->GetValue(), IXML_STR("%f"), pValue) == 1);
}

inline bool GetNamedAttribute_bool(IXMLData* pNode, bool *pValue, const IXML_ST* pName){
	IXMLData* pAttr;
	size_32 i;
	pAttr = pNode->GetNamedAttribute(pName, NULL);
	if (!pAttr || !pAttr->GetValue())
		return false;
	if (TStrICmp<IXML_ST>(pAttr->GetValue()) == "true"){
		*pValue = true;
		return true;
	}
	if (TStrICmp<IXML_ST>(pAttr->GetValue()) == "false"){
		*pValue = false;
		return true;
	}
	if (IXML_SCAN(pAttr->GetValue(), IXML_STR("%u"), &i) != 1)
		return false;
	*pValue = (i != 0);
	return true;
}

inline bool GetNamedAttribute_bool2(IXMLData* pNode, bool *pValue, const IXML_ST* pName){
	IXMLData* pAttr;
	size_32 i;
	pAttr = pNode->GetNamedAttribute(pName, NULL);
	if (!pAttr || !pAttr->GetValue())
		return false;
	if (*pAttr->GetValue() == 't' || *pAttr->GetValue() == 'T' || *pAttr->GetValue() == '1'){
		*pValue = true;
		return true;
	}
	*pValue = false;
	return true;
}

#endif //!_XMLHELPERS_H_
